﻿;*******************************************************************************
;								 IDENTIFICATION									
;								 --------------									
; Nom du fichier	: PCSC_Module.pbi
; Produit			    : 	
; Date de création: 08/03/2016
; Version de base	: 1.0														
; Auteur				  : A. SOURDRILLE
;********************************************************************************
CompilerIf  Not Defined( INC_PCSC_Module , #PB_Constant )
	
	#INC_PCSC_Module = #True
	
	IncludeFile "..\evt\PCSC_Events.pbi"
	
    CompilerSelect  #PB_Compiler_OS
        CompilerCase  #PB_OS_Windows
            
            CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
                Debug "#PB_Processor_x64"
                #PCSCFramework_Lib = "..\lib\x64\WinScard.lib"
            CompilerElse
                Debug "#PB_Processor_x86"
                #PCSCFramework_Lib = "..\lib\x86\WinScard.lib"
            CompilerEndIf      
            
            CompilerIf  #PB_Compiler_Unicode = #True
                Debug "Compilation UNICODE"
                Macro SCardConnect : SCardConnectW : EndMacro
                Macro SCardListReaders : SCardListReadersW : EndMacro
                Macro SCardGetStatusChange : SCardGetStatusChangeW : EndMacro
                Macro S_SCARD_READERSTATE : S_SCARD_READERSTATEW : EndMacro
            CompilerElse
                Debug "Compilation ASCII"
                Macro SCardConnect : SCardConnectA : EndMacro
                Macro SCardListReaders : SCardListReadersA : EndMacro
                Macro SCardGetStatusChange : SCardGetStatusChangeA : EndMacro
                Macro S_SCARD_READERSTATE : S_SCARD_READERSTATEA : EndMacro
            CompilerEndIf    
            
        CompilerCase  #PB_OS_MacOS
            Debug "Framework PCSC"
            #PCSCFramework_Lib = "-framework PCSC" 
    CompilerEndSelect
    
    CompilerIf  #PB_Compiler_Unicode = #True
        #PB_Sizeof_Car  = 2
    CompilerElse
        #PB_Sizeof_Car  = 1
    CompilerEndIf
    
    ;{ WinScard Constants }
    #SCARD_SCOPE_USER =       0
    #SCARD_SCOPE_TERMINAL =   1
    #SCARD_SCOPE_SYSTEM =     2
    
    #SCARD_S_SUCCESS =        0
    
    #SCARD_W_UNPOWERED_CARD = $80100067
    #SCARD_W_RESET_CARD =     $80100068
    #SCARD_W_REMOVED_CARD =   $80100069
    
    #SCARD_E_CANCELLED      = $80100002
    #SCARD_E_INVALID_HANDLE = $80100003
    #SCARD_E_NO_SMARTCARD   = $8010000C
    #SCARD_E_INVALID_VALUE =  $80100011  
    #SCARD_E_NO_READERS_AVAILABLE = $8010002E 
    
    #SCARD_SHARE_EXCLUSIVE =  1
    #SCARD_SHARE_SHARED =     2
    #SCARD_SHARE_DIRECT =     3
    
    #SCARD_PROTOCOL_T0 =      1
    #SCARD_PROTOCOL_T1 =      2
    #SCARD_PROTOCOL_Tx =      ( #SCARD_PROTOCOL_T0 + #SCARD_PROTOCOL_T1 )
    
    #SCARD_LEAVE_CARD =       0
    #SCARD_RESET_CARD =       1
    #SCARD_UNPOWER_CARD =     2
    #SCARD_EJECT_CARD =       3  
    
    #SCARD_CLASS_VENDOR_INFO =    $01
    #SCARD_CLASS_COMMUNICATIONS = $02
    #SCARD_CLASS_PROTOCOL =       $03
    #SCARD_CLASS_POWER_MGMT =     $04
    #SCARD_CLASS_SECURITY =       $05
    #SCARD_CLASS_MECHANICAL =     $06
    #SCARD_CLASS_VENDOR_DEFINED = $07
    #SCARD_CLASS_IFD_PROTOCOL =   $08
    #SCARD_CLASS_ICC_STATE =      $09
    #SCARD_CLASS_PERF =           $7FFE
    #SCARD_CLASS_SYSTEM =         $7FFF
    
    #SCARD_STATE_UNAWARE =        $0
    #SCARD_STATE_IGNORE  =        $1
    #SCARD_STATE_CHANGED =        $2
    #SCARD_STATE_UNKNOWN =        $4
    #SCARD_STATE_UNAVAILABLE =    $8
    #SCARD_STATE_EMPTY =          $10
    #SCARD_STATE_PRESENT =        $20
    #SCARD_STATE_ATRMATCH =       $40
    #SCARD_STATE_EXCLUSIVE =      $80
    #SCARD_STATE_INUSE =          $100
    #SCARD_STATE_MUTE =           $200
    #SCARD_STATE_UNPOWERED =      $400  
    
    #INFITE_TIMEOUT =   -1
    ;}
    
    #MAX_APDU_LENGTH = $FFFF
    
    Macro DWORD : l : EndMacro
    Macro SCARDCONTEXT : i : EndMacro
    Macro SCARDHANDLE : i : EndMacro
    
    Macro isBitSet(value,mask) : Bool(( value & mask ) = mask) : EndMacro
     
    ;{ WinScard Structures }
    Structure S_SCARD_IO_REQUEST
        dwProtocol.DWORD  ; Protocol identifier
        cbPciLength.DWORD ; Protocol Control Information Length
    EndStructure
    
    Structure S_SCARD_READERSTATE
        *szReader
        *pvUserData
        dwCurrentState.DWORD
        dwEventState.DWORD
        cbAtr.DWORD
        rgbAtr.a[36]
    EndStructure
    ;}  
    
    ;{ PCSC Framework/Library Importations }
    Import #PCSCFramework_Lib
        SCardEstablishContext	( dwScope.DWORD , *pvReserved1 , *pvReserved2 , *phContext )
        SCardReleaseContext		( hContext.SCARDCONTEXT )
        SCardIsValidContext		( hContext.SCARDCONTEXT )
        SCardListReaders	    ( hContext.SCARDCONTEXT , mzGroup.s , *ReaderList , *pcchReaders )				     
        SCardConnect			( hContext.SCARDCONTEXT , szReaderName.s , dwShareMode.DWORD , dwPrefProtocol.DWORD, *hCard , *pdwActiveProtocol )
        SCardReconnect			( hCard.SCARDHANDLE , dwShareMode.DWORD , dwPrefProtocol.DWORD, dwInitialization.DWORD, *pdwActiveProtocol )
        
        SCardDisconnect			( hCard.SCARDHANDLE , Disposistion.DWORD )   
        SCardGetAttrib			( hCard.SCARDHANDLE , dwAttrId.DWORD , pbAttr.DWORD , *pcbAttrLen )
        SCardGetStatusChange	( hContext.SCARDCONTEXT , dwTimeout.DWORD , *rgReaderStates.S_SCARD_READERSTATE , cReaders.DWORD )
        SCardTransmit			( hCard.SCARDHANDLE , *pioSendPci.S_SCARD_IO_REQUEST , pbSendBuffer.DWORD , cbSendLength.DWORD , *pioRecvRequest.S_SCARD_IO_REQUEST , *pbRecvBuffer , *pcbRecvLength )
    EndImport
    ;}  
    
CompilerEndIf
; IDE Options = PureBasic 5.50 (Windows - x86)
; CursorPosition = 19
; Folding = ----
; EnableXP
; CPU = 1
; CompileSourceDirectory